# yadosql.rb  version 1.5  2009/11/03
  # class Yado pf[^x[XENCAg
  # Copyright (C) T. Yoshiizumi, 2009 All rights reserved.
require 'yado'

# ʂɗp private method
  # ̗[̋󔒂폜BȊO͂̂܂ܕԂ
  def rm_both_space(s)
    unless s.class == String  # łȂ΂̂܂ܕԂ
      return s
    end
    s = s.sub(/^([ \t]|@)+/, "")
    s = s.sub(/([ \t]|@)+$/, "")
  end

  # Wo͂ւ̏o
  def stdout_message(str)
    if str != nil and str != ''
      if str =~ /\n\Z/
        str.split(/\n/).each {|line|
          STDOUT.puts line
        }
      else
        STDOUT.print str
      end
      STDOUT.flush  if $opt['flush']
      if $outfile != false and str != "\nYado>" and str != "->" and
          str != "Ok\n"
        $outfile.print str
        $outfile.flush
      end
    end
  end

  # WG[o͂ւ̏o
  def stderr_message(str)
    if str != nil and str != ''
      if str =~ /\n\Z/
        str.split(/\n/).each {|line|
          STDERR.puts line
        }
      else
        STDERR.print str
      end
      STDERR.flush  if $opt['flush']
      if $outfile != false
        $outfile.print str
        $outfile.flush
      end
    end
  end

  # w肳ꂽt@C΃pXŕԂ
  def getAbsolutePath(filename)
    filename = filename.gsub(/\//, "\\")
    fso = WIN32OLE.new('Scripting.FileSystemObject')
    return fso.GetAbsolutePathName(filename)
  end

#  \̌`ɐBformat_sw != 'YES' ̎̓^u؂̌`Ԃ
  # 80𒴂鎞͉ӏɂ
  # ߂l̂Psڂ [`^Cv, s]
  # `^Cv: "table", "tab", "list"
def table_format(aa, format_sw='YES', header_sw='NO_HEADER')
  r = Array.new  # ߂l
  if aa.size < 1
    return r
  end
  max = Array.new  # eX̃tB[h̍ő咷L^
  for i in 0...aa.size
    for j in 0...aa[i].size
      if aa[i][j] =~ /^(\d+\/\d+\/\d+) +00\:00\:00$/
        aa[i][j] = $1
      end
      max[j] = 0  if max[j] == nil
      m = aa[i][j].to_s.length
      if m > max[j]
        max[j] = m
      end
    end
  end
      # format_sw != 'YES' ܂̓JP̎̓^u؂Ԃ
  if format_sw != 'YES' or max[1] == nil
    r << ["tab", aa.size - (header_sw == 'ADD_HEADER' ? 1 : 0)]
    aa.each {|rs|  r << rs.join("\t")}
    return r
  end
      # vZ
  total_len = 0
  max.each {|i|  total_len += (i+2)}
  total_len -= 2
      # 80𒴂鎞͉ӏɂ
  if total_len > 80
    if header_sw == 'NO_HEADER'
      r << ["tab", aa.size]
      aa.each {|rs|  r << rs.join("\t")}
    else  # ӏX^Cɂ
      r << ["list", aa.size-1]
      headers = aa[0]
      for i in 1...aa.size
        rs = aa[i]
        r << sprintf("- %s: %s", headers[0], rs[0])
        for j in 1...rs.size
          r << sprintf("  %s: %s", headers[j], rs[j])
        end
      end
    end
    return r
  end
      # 𑵂Ė߂lZbg
  r << ["table", aa.size - (header_sw == 'ADD_HEADER' ? 1 : 0)]
  aa.each {|rs|
    str = ''
    for i in 0...(rs.size-1)
      fmt = sprintf("%%-%ds", max[i]+2)
      str = str + sprintf(fmt, rs[i])
    end
    i = rs.size-1
    fmt = sprintf("%%-%ds", max[i])
    str = str + sprintf(fmt, rs[i])
    r << str
  }
  return r
end

# \`̃f[^Wo͂ɏóB_CNgĂ鎞̓^u؂ŁB
def print_table(aa, header_sw='NO_HEADER')
  if STDOUT.tty? or $opt['flush']
    format_sw = 'YES'
  else
    format_sw = 'NO'
  end
  aa.each_index {|i|
    aa[i].each_index {|j|
      aa[i][j] = aa[i][j].to_s.gsub(/\n/m, "\x1f|")  # sϊ
    }
  }
  rstr = table_format(aa, format_sw, header_sw)
  if rstr.size > 0
    first = rstr.shift
    line_num = first[1]
    rstr.each {|rs|  stdout_message rs + "\n"}
    stdout_message sprintf("*s  %d\n\n", line_num)
  end
end

# wvbZ[W̏o
def help
  msg = <<EOS1
R}h
    exit: I [\\q, quit]
    help: wvbZ[W̏o [\\h, \\?]
    source input.txt: ׂ͂et@Cǂݍ [\\.]
    load input.xml table_name: xml|adtgǂݍŃe[u쐬 [\\l]
    tee output.txt: ƒ̏o͂𑍂output.txtɏo͂ [\\T]
    notee: teeɂt@Co͎w [\\t]
    xtee output.xml: SQL̎sʂoutput.xmlɏo͂ [\\x]
    clear: ͒̃R}h(ŏ͂Ɏw) [\\c]
    go: ͂ĂR}hs [\\g]
    system application.exe: OR}hs [\\!]
    create database test.mdb: f[^x[X test.mdb Vɍ쐬
    use test.mdb: f[^x[X test.mdb ɐڑ [\\u]
    drop database test.mdb: f[^x[X test.mdb 폜(쒆͕̂̂s)
    show tables: f[^x[X̃e[uꗗ\Bdetailtɂڍ׏
    show fields: tB[ḧꗗ\Be[uw
    show error: ŐṼG[bZ[W\
    show database: ڑ̃f[^x[X\(`łȂ̂Œ)
NIvV
    -u admin: [U[ admin ƂċN
    --password=xyz123: pX[h xyz123 ƂċN
    -p: YadoSQLNɃpX[h͂̏ʂɂȂ
    -s file.txt: Nfile.txtɏĂR}hs
    -f: o͂̃tbVs悤ɂ(Altairshell[hɎgp)
    -h ܂ -?: wvbZ[W̏o
EOS1
  stderr_message msg + "\n"
end

# IȌ
def terminator
  $outfile.close  unless $outfile == false
  File.unlink($outfile_name)  if $outfile_name != nil and test(?z, $outfile_name)
  if $db.db_name != nil
    outfile = (open($dat_file, "w")  rescue  false)
    unless outfile == false
      outfile.puts $db.db_name
      outfile.close
    end
  end
  $db.close
end

# SQLɊ֌WȂR}h̎s@exit, help Ȃ
def command_exec(line)
  str = line
  str = str.sub(/\s*;$/m, "")
  r = ''
  if str =~ /^#/  # Rgs
    r = 'NEXT'
  elsif str =~ /^\s*$/  # 󔒕݂̂̍s
    r = 'NEXT'
  elsif str == '\q' or str =~ /^exit$|^quit$/i
    r = 'EXIT'
  elsif str == '\h' or str == '\?' or str =~ /^help$/i
    help
     r = 'NEXT'
  elsif str =~ /^(\\\.|source)\s+(\S.+)/im
    fname = getAbsolutePath($2)
    input_exec(fname)
    r = 'NEXT'
  elsif str =~ /^(\\l|load)\s+(\S.+)\s+(\S.+)/im
    fname = getAbsolutePath($2)
    tblname = $3
    $db.load_persist(fname, tblname)
    r = 'NEXT'
  elsif str =~ /^(\\T|[Tt][Ee][Ee])\s+(\S.+)$/m
    fname = getAbsolutePath($2)
    if $outfile_name != nil and fname.casecmp($outfile_name) == 0 and
       $outfile != false
      stderr_message sprintf("%sɏo͒ł.\n", fname)
    else
      outfile = (open(fname, "a")  rescue  false)
      if outfile != false
        $outfile.close  unless $outfile == false
        if $opt['source'] == ''
          stderr_message sprintf("\%sɏo͂܂.\n", fname)
        end
        $outfile = outfile
        $outfile_name = fname
      else
        stderr_message sprintf("%sJ܂ł.\n", fname)
      end
    end
    r = 'NEXT'
  elsif str =~ /^(\\T|[Tt][Ee][Ee])$/m
    if $outfile_name != nil
      if $outfile != false
        stderr_message sprintf("%sɏo͒ł.\n", $outfile_name)
      else
        outfile = (open($outfile_name, "a")  rescue  false)
        if outfile != false
          stderr_message sprintf("\%sɏo͂܂.\n", $outfile_name)
          $outfile = outfile
        else
          stderr_message sprintf("%sJ܂ł.\n", $outfile_name)
        end
      end
    else
      stderr_message "o̓t@C̎w肪܂.\n"
    end
    r = 'NEXT'
  elsif str == '\t' or str =~ /^notee$/i
    $outfile.close  unless $outfile == false
    $outfile = false
    if $outfile_name != nil
      stderr_message sprintf("%sւ̏o͂𒆒f܂.\n", $outfile_name)
    else
      stderr_message "t@Cւ̏o͍͂sĂ܂.\n"
    end
    r = 'NEXT'
  elsif str =~ /^(\\x|[Xx][Tt][Ee][Ee])\s+(\S.+)$/m
    fname = getAbsolutePath($2)
    if test(?e, fname)
      stderr_message sprintf("w̃t@Cɑ݂܂: %s\n", fname)
    else
      outfile = (open(fname, "ab")  rescue  false)
      if outfile != false
        outfile.close
        File.unlink(fname)
        if $opt['source'] == ''
          stderr_message sprintf("%s  Ok\n", fname)
        end
        $xfile_name = fname
      else
        stderr_message sprintf("%sJ܂.\n", fname)
      end
    end
    r = 'NEXT'
  elsif str =~ /^\\!|system/i
    if str =~ /^(\\!|system\s+)(\S.*)$/i
      child_cmd = $2
      child_cmd = rm_both_space(child_cmd)
    else
      child_cmd = "CMD.EXE"
    end
    tee_sw = 0
    if $outfile != false
      $outfile.close
      $outfile = false
      tee_sw = 1
    end
    system( child_cmd )
    if tee_sw == 1
      $outfile = (open($outfile_name, "a")  rescue  false)
      if $outfile == false
        stderr_message sprintf("o̓t@C%săI[vł܂.\n",
            $outfile_name)
      end
    end
    r = 'NEXT'
  end
  return r
end

# SQLȂǃf[^x[XɊւR}h̎s
def query_exec(cmd)
  cmd.chomp!
  cmd = rm_both_space(cmd)
  cmd = cmd.sub(/\s*;$/m, "")
  if cmd =~ /^([ \t]|\n|@)*$/m
    return
  end

  r = []
  if cmd =~ /^create\s+database/im
    if cmd =~ /^create\s+database\s+(\S.*)$/im
      arg = $1
      r = $db.create_db arg, $opt['user'], $opt['password']
      if r == 'LOSE'
        stderr_message sprintf("%s쐬ł܂.\n", arg)
      elsif r == 'EXIST'
        stderr_message sprintf("%s͊ɑ݂܂.\n", arg)
      else
        $command_list << cmd
        stdout_message "Ok\n"
      end
    else
      stderr_message "쐬ׂf[^x[X̎w肪܂.\n"
    end
  elsif cmd =~ /^\\u|[Uu][Ss][Ee]/
    if cmd =~ /^(\\u|[Uu][Ss][Ee])\s+(\S.*)$/m
      arg = $2
      r = $db.open_db arg, $opt['user'], $opt['password']
      if r == false
        stderr_message sprintf("%sɐڑł܂.\n", arg)
      else
        $command_list << cmd
        stdout_message "Ok\n"
      end
    else
      stderr_message "ڑׂf[^x[X̎w肪܂.\n"
    end
  elsif cmd =~ /^drop\s+database/im
    if cmd =~ /^drop\s+database\s+(\S.*)$/im
      arg = $1
      r = $db.drop_db arg
      if r == 'LOSE'
        stderr_message sprintf("%s폜ł܂.\n", arg)
      else
        $command_list << cmd
        stdout_message "Ok\n"
      end
    else
      stderr_message "폜ׂf[^x[X̎w肪܂.\n"
    end
  elsif cmd =~ /^show\s+tables$/im
    r = $db.list_tables
    ra = Array.new
    r.each {|ts|
      if ts.Type == 'TABLE'
        ra << [ts.Name]
      end
    }
    if ra.size == 0
      stdout_message "e[u܂.\n"
    else
      stdout_message sprintf("e[uꗗ (%s)\n", $db.db_name)
      print_table(ra)
      $command_list << cmd
    end
  elsif cmd =~ /^show\s+tables\s+details?$/im
    r = $db.list_tables
    ra = Array.new
    r.each {|ts|
      if ts.Type == 'TABLE' or ts.Type == 'VIEW'
        ra << [ts.Name, ts.Type, ts.DateCreated, ts.DateModified]
      end
    }
    if ra.size == 0
      stdout_message "e[u܂.\n"
    else
      stdout_message sprintf("e[uꗗ ڍ (%s)\n", $db.db_name)
      ra.unshift ["O", "", "쐬", "XV"]
      print_table(ra)
      $command_list << cmd
    end
  elsif cmd =~ /^show\s+errors?$/im
    if $db.error.last != nil and $db.error.last != ''
      stderr_message $db.error.last + "\n\n"
    else
      stderr_message "G[bZ[W͂܂.\n"
    end
  elsif cmd =~ /^select\s+database\(\)$|^show\s+database$/im
    s = $db.db_name
    if s != nil
      stdout_message sprintf("ڑ̃f[^x[X: %s\n", s)
    else
      stdout_message sprintf("ڑ̃f[^x[X: Ȃ\n")
    end
    $command_list << cmd
  elsif cmd =~ /^show\s+fields(.*)$/im
    tblname = $1
    tblname = rm_both_space(tblname)  unless tblname == ''
    tbl_count = 0
    $db.list_tables {|ts|
      if tblname != '' and ts.Name != tblname
        next
      elsif tblname == '' and ts.Type != 'TABLE' and ts.Type != 'VIEW'
        next
      end
      stdout_message sprintf("%s (%s)\n", ts.Name, ts.Type)
      tbl_count += 1
      r = $db.get_field_info(ts)
      r.shift  # e[ȕ͍폜
      print_table(r)
    }
    if tbl_count == 0
      stderr_message "tB[h𓾂܂ł.\n"
    end
  elsif cmd =~ /^show\s+|^use\s+|^select\s+user\(\)/im
        # SQL߂ƂĎsȂ悤ɁAΉ̂̂Ő؂
    stderr_message sprintf("ΉĂȂR}h: %s\n", cmd)
  elsif $db.status == false
    stderr_message "f[^x[XɐڑĂ܂.\n"
  else
    result = $db.query_result(cmd, :EXCEPT)
    if result == nil
      if $db.error.last != nil
        stderr_message $db.error.last + "\n\n"
      end
    else
      r = []
      fldnames = result.list_field_names
      if fldnames.size > 0
        r << fldnames  
        result.each {|rs|
          r << rs
        }
      end
      if r.size > 0
        print_table(r, 'ADD_HEADER')
        if $xfile_name != nil and $xfile_name !~ /\.(adtg|xml)$/i
          result.print_all_values $xfile_name
          if $opt['source'] == ''
            stderr_message sprintf("%s  Close\n", $xfile_name)
          end
          $xfile_name = nil
        end
      else
        stdout_message "Ok\n"
      end
      $command_list << cmd
      result.free
    end
    if $xfile_name != nil and $xfile_name =~ /\.(adtg|xml)$/i
      if $db.query_persist(cmd, $xfile_name) == :SUCCESS
        if $opt['source'] == ''
          stderr_message sprintf("%s  Close\n", $xfile_name)
        end
        $xfile_name = nil
      end
    end
  end
end

# ͂ǂݎĎs
def input_exec(filename=nil)
  if filename != nil
    infile = (open(filename)  rescue  false)
    if infile == false
      stderr_message sprintf("%sJ܂ł.\n", filename)
      return
    end
    body = infile.read
    infile.close
    body.sub!(/\A.*\n###+\n/im, "")
    lines = body.split(/\n/)
  else
    infile = STDIN
  end
  cmd = ''
  while true
    if infile == STDIN
      if cmd == ''
        stdout_message "\nYado>"
      else
        stdout_message "->"
      end
      unless  infile.gets
        break
      end
      line = $_.chomp
    else
      unless line = lines.shift
        break
      end
    end
    line = rm_both_space(line)
    next  if line == ''
    if cmd == ''
      res = command_exec(line)
      if res == 'EXIT'
        terminator
        exit
      elsif res == 'NEXT'
        next
      end
    end
        #  ͓rŎwłR}h clear, print, go
    if line == '\c' or line =~ /^clear;?$/i
      cmd = ''
      next
    elsif line == '\p' or line =~ /^print;?$/i
      stdout_message cmd
      next
    elsif line == '\g' or line =~ /^go;?$/i
      cmd = cmd + ';'
    else  # Yp^[Ȃ̂ŃR}ḧ̓͂Ƃ݂Ȃ
      cmd = cmd + line
      unless cmd =~ /;$/
        cmd = cmd + "\n"
      end
    end
    if cmd =~ /;$/
      query_exec(cmd)
      cmd = ''
    end
  end
end

## main
    # yadosql.exe݂fBNg擾
begin
  org_dir = File.dirname(ExerbRuntime::filepath())
rescue
  org_dir = ENV['HOMEDRIVE'] + ENV['HOMEPATH']
end
org_dir.gsub!(/\//, "\\")
if org_dir =~ /\\$/
  org_dir = org_dir.sub(/\\$/, "")
end
$dat_file = org_dir + "\\yadosql.dat"

$command_list = Array.new  # ɎsꂽR}hɋL^
$outfile = false  # o̓t@C̃nh
$outfile_name = nil  # o̓t@C̖O
$opt = Hash.new

$opt['user'] = 'admin'
$opt['password'] = ''
$opt['flush'] = false
$opt['source'] = ''
wargv = []
while arg = ARGV.shift
  if arg == '-u' and ARGV.size > 0
    $opt['user'] = ARGV.shift
  elsif arg =~ /^-u(.+)$/
    $opt['user'] = $1
  elsif arg =~ /^--user=(.+)$/
    $opt['user'] = $1
  elsif arg =~ /^--password=(.+)$/
    $opt['password'] = $1
  elsif arg == '-p'
    $opt['password'] = '?'
  elsif arg == '-f' or arg == '--flush'
    $opt['flush'] = true
  elsif arg == '-s' and ARGV.size > 0
    $opt['source'] = ARGV.shift
  elsif arg =~ /^-s(.+)$/
    $opt['source'] = $1
  elsif arg =~ /^--source=(.+)$/
    $opt['source'] = $1
  else
    wargv << arg
  end
end
if $opt['source'] != ''
  $opt['source'] = getAbsolutePath($opt['source'])
  source_path = File.dirname($opt['source'])
else
  source_path = ''
end

if $opt['password'] == '?'
  stderr_message sprintf("password?: ")
  gets
  $opt['password'] = $_.chomp
end
if wargv.size == 0 and test(?s, $dat_file)
  infile = (open($dat_file)  rescue  false)
  unless infile == false
    db_name = infile.gets
    db_name.chomp!
    infile.close
    wargv << db_name  if test(?e, db_name)
  end
end
if wargv.size > 0
  $db = Yado.new wargv[0], $opt['user'], $opt['password']
else
  $db = Yado.new
end
$db.error.switch(0)  # YadoNXł̃G[o͂}

if $opt['source'] != ''
  tee_name = source_path + "\\YadoOut.txt"
  File.unlink(tee_name)  if test(?e, tee_name)
  command_exec("tee #{tee_name}")
  input_exec $opt['source']
else
  stderr_message "YadoSQL WindowsADOɂf[^x[X version 1.5\n" + 
      "    \\qFI    \\hFwv\\n"
  s = $db.db_name
  if s != nil
    stdout_message sprintf("ڑ̃f[^x[X: %s\n", s)
  end
  input_exec
end
terminator
